package com.lantone.qc.kernel.catalogue.behospitalized;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.model.entity.ConjugalRelation;
import com.lantone.qc.pub.util.StringUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

/**
 * @Description: 夫妻关系未描述
 * @author: rengb
 * @time: 2020/3/10 14:02
 */
@Component
public class BEH0056 extends QCCatalogue {

    @Override
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        //婚育史未填写，直接返回；
        if (inputInfo.getBeHospitalizedDoc().getMaritalLabel() == null
                || StringUtils.isEmpty(inputInfo.getBeHospitalizedDoc().getMaritalLabel().getText())) {
            status.set("0");
            return;
        }

        ConjugalRelation conjugalRelation = inputInfo.getBeHospitalizedDoc().getMaritalLabel().getConjugalRelation();
        long cont = inputInfo.getBeHospitalizedDoc().getMaritalLabel()
                .getFamily().stream()
                .filter(family -> family.getName().contains("配偶") && family.getDead()!=null).count();
        if (conjugalRelation != null) {
            if(StringUtil.isNotBlank(conjugalRelation.getName()) || cont > 0){
                status.set("0");
            }
        }
        //硬规则 匹配离婚
        if (inputInfo.getBeHospitalizedDoc().getMaritalLabel().getText().contains("离婚")) {
            status.set("0");
        }
    }

}